To have an efficient push-pull algorithm, we are interested by the following properties:

\begin{itemize}
  \item a good dissemination of the existence of a message (mainly its identifier)
  \item choosing efficiently how to ask for missing messages
  \item estimating efficiently the number of missing messages to adapt 
\end{itemize}

As a reminder, we have three information in a network coded packet: a
generation id, a list of messages id and their corresponding
coefficient value and finally the encoded message.
Every packets that contain a network coded packet also contain information about all the messages ids in the generation known by the sender.

Unfortunately, even if this approach helps to disseminate the
information about existing message identifiers\df{This was not clear
  to the reader before now. Remember the scheme: problem statement ->
  solution. As you explain the protocol's features, say first why you
  need them and then how you do them, or alternatively, state
  everything upfront without explaining why, and explain the why
  later.}, it has one drawback: the last added messages to a
generation will disseminate the information of all the other messages
of the generation, but will disseminate its own existence only
once. 
As decoding is costly and delays the message delivery, we perform a partial decoding each time we receive a packet, spreading the CPU load over time and decode messages as soon as possible.

To improve the message dissemination, we can keep a list of newly discovered message identifiers with their associated generation and send a part of this list (which will call our trading window) with every messages sent by the protocol. The size of the trading window and the potential shift from the last added messages, named safety margin are protocol parameters.

We ask for a specific generation list, computed by keeping the generation of each known messages ids that are not decoded. The target node doesn't know if it haves more information than the asker and could send useless information. At the same time, there is no other solution than asking the target node to generate a linear combination and try to add it to our local matrix to know if the target node can provide useful information.
Asking specific ids would be useless as if the remote node answer only if it has decoded the ids, we lost the benefits of RLNC.
Otherwise, if the remote node answer if it has some knowledge of the requested message, nothing prove that this knowledge of the node is not redundant with ours.
Furthermore, during our tests,
it appears that blindly sending a generation didn't increase the number of redundant
packets compared to a traditionnal Push-Pull algorithm asking for a message identifier list while greatly decreasing message sizes (sending a generation identifier instead of its list of messages is quite efficient).

To provide adaptiveness, estimating the number of useful packets needed to receive all the missing messages is needed by some protocols.
Without network coding, the number of needed packets corresponds to the number of missing messages.
With network coding, partially decoded packets are also considered as missing messages, but to decode them we could need less packets than missing messages.
In this case, the number of useful packets needed corresponds to the number of independant linear combinations needed.
By substracting the rank of a generation to the total number of message identifiers known for this generation, we can determine the number of linear combination we need for this generation.
We just apply this rule for all the known generations and report this value.
